# coding: utf-8
"""
<copyright company="Aspose" file="CellValuepy.cs">
  Copyright (c) 2025 Aspose.Cells Cloud
</copyright>
<summary>
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
</summary>
"""

from pprint import pformat
from six import iteritems
import re

class CellValue(object):

    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """

    swagger_types = {
        'row_index' : 'int',
        'column_index' : 'int',
        'type' : 'str',
        'value' : 'str',
        'formula' : 'str',
        'style' : 'Style'
    }

    attribute_map = {
        'row_index' : 'rowIndex' ,
        'column_index' : 'columnIndex' ,
        'type' : 'type' ,
        'value' : 'value' ,
        'formula' : 'formula' ,
        'style' : 'style' 
    }

    @staticmethod
    def get_swagger_types():
        return CellValue.swagger_types

    @staticmethod
    def get_attribute_map():
        return CellValue.attribute_map

    def get_from_container(self, attr):
        if attr in self.container:
            return self.container[attr]
        return None

    def __init__(self,row_index=None ,column_index=None ,type=None ,value=None ,formula=None ,style=None   ,**kw):
        """
        Associative dict for storing property values
        """
        self.container = {}

        """
        CellValue - a model defined in Swagger
        """
        self.container['row_index'] = None 
        self.container['column_index'] = None 
        self.container['type'] = None 
        self.container['value'] = None 
        self.container['formula'] = None 
        self.container['style'] = None 
        params = locals()
        self.row_index = row_index
        if 'row_index' in params:
            self.row_index = params["row_index"]


             
        self.column_index = column_index
        if 'column_index' in params:
            self.column_index = params["column_index"]


             
        self.type = type
        if 'type' in params:
            self.type = params["type"]


             
        self.value = value
        if 'value' in params:
            self.value = params["value"]


             
        self.formula = formula
        if 'formula' in params:
            self.formula = params["formula"]


             
        self.style = style
        if 'style' in params:
            self.style = params["style"]


             

    @property
    def row_index(self):
        return self.container['row_index']

    @row_index.setter
    def row_index(self, row_index):
        self.container['row_index'] = row_index 
    @property
    def column_index(self):
        return self.container['column_index']

    @column_index.setter
    def column_index(self, column_index):
        self.container['column_index'] = column_index 
    @property
    def type(self):
        return self.container['type']

    @type.setter
    def type(self, type):
        self.container['type'] = type 
    @property
    def value(self):
        return self.container['value']

    @value.setter
    def value(self, value):
        self.container['value'] = value 
    @property
    def formula(self):
        return self.container['formula']

    @formula.setter
    def formula(self, formula):
        self.container['formula'] = formula 
    @property
    def style(self):
        return self.container['style']

    @style.setter
    def style(self, style):
        self.container['style'] = style 

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.get_swagger_types()):
            value = self.get_from_container(attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CellValue):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other    